searchData={"items":[{"type":"module","title":"Azurex","doc":"Azure connection library.\nCurrently only implements Blob Storage.","ref":"Azurex.html"},{"type":"module","title":"Azurex.Authorization.SharedKey","doc":"Implements Azure Rest Api Authorization method.\n\nIt is based on: https://docs.microsoft.com/en-us/rest/api/storageservices/authorize-with-shared-key\nAs defined in 26 November 2019","ref":"Azurex.Authorization.SharedKey.html"},{"type":"function","title":"Azurex.Authorization.SharedKey.format_date/1","doc":"","ref":"Azurex.Authorization.SharedKey.html#format_date/1"},{"type":"function","title":"Azurex.Authorization.SharedKey.sign/2","doc":"","ref":"Azurex.Authorization.SharedKey.html#sign/2"},{"type":"module","title":"Azurex.Blob","doc":"Implementation of Azure Blob Storage.\n\nIn the functions below set container as nil to use the one configured in `Azurex.Blob.Config`.","ref":"Azurex.Blob.html"},{"type":"function","title":"Azurex.Blob.copy_blob/3","doc":"Copies a blob to a destination.","ref":"Azurex.Blob.html#copy_blob/3"},{"type":"function","title":"Azurex.Blob.delete_blob/3","doc":"","ref":"Azurex.Blob.html#delete_blob/3"},{"type":"function","title":"Azurex.Blob.get_blob/3","doc":"Download a blob","ref":"Azurex.Blob.html#get_blob/3"},{"type":"function","title":"Examples - Azurex.Blob.get_blob/3","doc":"iex> get_blob(\"filename.txt\")\n    {:ok, \"file contents\"}\n\n    iex> get_blob(\"filename.txt\", \"container\")\n    {:ok, \"file contents\"}\n\n    iex> get_blob(\"filename.txt\", nil, timeout: 10)\n    {:ok, \"file contents\"}\n\n    iex> get_blob(\"filename.txt\")\n    {:error, %HTTPoison.Response{}}","ref":"Azurex.Blob.html#get_blob/3-examples"},{"type":"function","title":"Azurex.Blob.get_url/1","doc":"Returns the url for a container (defaults to the one in `Azurex.Blob.Config`)","ref":"Azurex.Blob.html#get_url/1"},{"type":"function","title":"Azurex.Blob.get_url/2","doc":"Returns the url for a file in a container (defaults to the one in `Azurex.Blob.Config`)","ref":"Azurex.Blob.html#get_url/2"},{"type":"function","title":"Azurex.Blob.head_blob/3","doc":"Checks if a blob exists, and returns metadata for the blob if it does","ref":"Azurex.Blob.html#head_blob/3"},{"type":"function","title":"Azurex.Blob.list_blobs/2","doc":"Lists all blobs in a container","ref":"Azurex.Blob.html#list_blobs/2"},{"type":"function","title":"Examples - Azurex.Blob.list_blobs/2","doc":"iex> Azurex.Blob.list_blobs()\n    {:ok, \"﻿  Azurex.Blob.list_blobs()\n    {:error, %HTTPoison.Response{}}","ref":"Azurex.Blob.html#list_blobs/2-examples"},{"type":"function","title":"Azurex.Blob.list_containers/0","doc":"","ref":"Azurex.Blob.html#list_containers/0"},{"type":"function","title":"Azurex.Blob.put_blob/5","doc":"Upload a blob.","ref":"Azurex.Blob.html#put_blob/5"},{"type":"function","title":"The `blob` Argument - Azurex.Blob.put_blob/5","doc":"The blob argument may be either a `binary` or a tuple of\n`{:stream, Stream.t()}`.","ref":"Azurex.Blob.html#put_blob/5-the-blob-argument"},{"type":"function","title":"The `content_type` Argument - Azurex.Blob.put_blob/5","doc":"This argument can be either a valid string, or `nil`. A `content_type`\nargument of `nil` will result in the blob being assigned the default content\ntype `\"application/octet-stream\"`.","ref":"Azurex.Blob.html#put_blob/5-the-content_type-argument"},{"type":"function","title":"Examples - Azurex.Blob.put_blob/5","doc":"iex> put_blob(\"filename.txt\", \"file contents\", \"text/plain\")\n    :ok\n\n    iex> {:ok, io_device} = StringIO.open(\"file contents as a stream\")\n    byte_length = 8_000_000\n    bitstream = IO.binstream(io_device, byte_length)\n    put_blob(\"filename.txt\", {:stream, bitstream}, nil)\n    :ok\n\n    iex> put_blob(\"filename.txt\", \"file contents\", \"text/plain\", \"container\")\n    :ok\n\n    iex> put_blob(\"filename.txt\", \"file contents\", \"text/plain\", nil, timeout: 10)\n    :ok\n\n    iex> put_blob(\"filename.txt\", \"file contents\", \"text/plain\")\n    {:error, %HTTPoison.Response{}}","ref":"Azurex.Blob.html#put_blob/5-examples"},{"type":"module","title":"Azurex.Blob.Block","doc":"Implementation of Azure Blob Storage.\n\nYou can:\n\n- [upload a block as part of a blob](https://learn.microsoft.com/en-us/rest/api/storageservices/put-block)\n- [commit a list of blocks as part of a blob](https://learn.microsoft.com/en-us/rest/api/storageservices/put-block-list)","ref":"Azurex.Blob.Block.html"},{"type":"function","title":"Azurex.Blob.Block.put_block/4","doc":"Creates a block to be committed to a blob.\n\nOn success, returns an :ok tuple with the base64 encoded block_id.","ref":"Azurex.Blob.Block.html#put_block/4"},{"type":"function","title":"Azurex.Blob.Block.put_block_list/5","doc":"Commits the given list of block_ids to a blob.\n\nBlock IDs should be base64 encoded, as returned by put_block/2.","ref":"Azurex.Blob.Block.html#put_block_list/5"},{"type":"module","title":"Azurex.Blob.Config","doc":"Azurex Blob Config","ref":"Azurex.Blob.Config.html"},{"type":"function","title":"Azurex.Blob.Config.api_url/0","doc":"Azure endpoint url, optional\nDefaults to `https://{name}.blob.core.windows.net` where `name` is the `storage_account_name`","ref":"Azurex.Blob.Config.html#api_url/0"},{"type":"function","title":"Azurex.Blob.Config.default_container/0","doc":"Azure container name, optional.","ref":"Azurex.Blob.Config.html#default_container/0"},{"type":"function","title":"Azurex.Blob.Config.get_connection_string_value/1","doc":"Returns the value in the connection string given the string key.","ref":"Azurex.Blob.Config.html#get_connection_string_value/1"},{"type":"function","title":"Azurex.Blob.Config.parse_connection_string/1","doc":"Parses a connection string to a key value map.","ref":"Azurex.Blob.Config.html#parse_connection_string/1"},{"type":"function","title":"Examples - Azurex.Blob.Config.parse_connection_string/1","doc":"iex> parse_connection_string(\"Key=value\")\n    %{\"Key\" => \"value\"}\n\n    iex> parse_connection_string(\"Key1=hello;Key2=world\")\n    %{\"Key1\" => \"hello\", \"Key2\" => \"world\"}\n\n    iex> parse_connection_string(nil)\n    %{}","ref":"Azurex.Blob.Config.html#parse_connection_string/1-examples"},{"type":"function","title":"Azurex.Blob.Config.storage_account_connection_string/0","doc":"Azure storage account connection string.\nRequired if `storage_account_name` or `storage_account_key` not set.","ref":"Azurex.Blob.Config.html#storage_account_connection_string/0"},{"type":"function","title":"Azurex.Blob.Config.storage_account_key/0","doc":"Azure storage account access key. Base64 encoded, as provided by azure UI.\nRequired if `storage_account_connection_string` not set.","ref":"Azurex.Blob.Config.html#storage_account_key/0"},{"type":"function","title":"Azurex.Blob.Config.storage_account_name/0","doc":"Azure storage account name.\nRequired if `storage_account_connection_string` not set.","ref":"Azurex.Blob.Config.html#storage_account_name/0"},{"type":"module","title":"Azurex.Blob.Container","doc":"Implementation of Azure Blob Storage","ref":"Azurex.Blob.Container.html"},{"type":"function","title":"Azurex.Blob.Container.create/1","doc":"","ref":"Azurex.Blob.Container.html#create/1"},{"type":"function","title":"Azurex.Blob.Container.head_container/1","doc":"","ref":"Azurex.Blob.Container.html#head_container/1"},{"type":"module","title":"Azurex.Blob.SharedAccessSignature","doc":"Implements shared access signatures (SAS) on Blob Storage resources.\n\nBased on:\nhttps://learn.microsoft.com/en-us/rest/api/storageservices/create-service-sas","ref":"Azurex.Blob.SharedAccessSignature.html"},{"type":"function","title":"Azurex.Blob.SharedAccessSignature.sas_url/3","doc":"Generates a SAS url on a resource in a given container.","ref":"Azurex.Blob.SharedAccessSignature.html#sas_url/3"},{"type":"function","title":"Params - Azurex.Blob.SharedAccessSignature.sas_url/3","doc":"- container: the storage container name\n- resource: the path to the resource (blob, container, directory...)\n- opts: an optional keyword list with following options\n  - resource_type: one of :blob / :blob_version / :blob_snapshot / :container / directory\n    Defaults to :container\n  - permissions: a list of permissions. Defaults to [:read]\n  - from: a tuple to defined when the SAS url validity begins. Defaults to `now`.\n  - expiry: a tuple to set how long before the SAS url expires. Defaults to `{:second, 3600}`.","ref":"Azurex.Blob.SharedAccessSignature.html#sas_url/3-params"},{"type":"function","title":"Examples - Azurex.Blob.SharedAccessSignature.sas_url/3","doc":"- `SharedAccessSignature.sas_url(\"my_container\", \"/\", permissions: [:write], expiry: {:day, 2})`\n- `SharedAccessSignature.sas_url(\"my_container\", \"foo/song.mp3\", resource_type: :blob)`","ref":"Azurex.Blob.SharedAccessSignature.html#sas_url/3-examples"}],"content_type":"text/markdown"}